﻿namespace ProjectMonorail.Scripts.Monorail.Drawnings
{
    public class DrawningMonorailCompareByType : IComparer<DrawingMonorail?>
    {
        public int Compare(DrawingMonorail? x, DrawingMonorail? y)
        {
            if (x == null || x.EntityMonorail == null)
            {
                return 1;
            }

            if (y == null || y.EntityMonorail == null)
            {
                return -1;
            }

            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }

            var speedCompare = x.EntityMonorail.Speed.CompareTo(y.EntityMonorail.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityMonorail.Weight.CompareTo(y.EntityMonorail.Weight);
        }
    }
}
