﻿using ProjectMonorail.Scripts.Monorail.Entities;

namespace ProjectMonorail.Scripts.Monorail.Drawnings
{
    /// <summary>
    /// Расширение для класса EntityMonorail
    /// </summary>
    public static class ExtentionDrawningMonorail
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly string _separatorForObject = ":";

        public static DrawingMonorail? CreateDrawingMonorail(this string info)
        {
            string[] args = info.Split(_separatorForObject);
            EntityMonorail? monorail = EntityModernMonorail.CreateEntityModernMonorail(args);

            if (monorail != null) return new DrawingModernMonorail((EntityModernMonorail)monorail);

            monorail = EntityMonorail.CreateEntityMonorail(args);

            if (monorail != null) return new DrawingMonorail(monorail);

            return null;
        }

        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawingMonorail"></param>
        /// <returns></returns>
        public static string GetDataForSave(this DrawingMonorail drawingMonorail)
        {
            string[]? array = drawingMonorail?.EntityMonorail?.GetStringRepresention();

            if (array == null)
                return string.Empty;

            return string.Join(_separatorForObject, array);
        }
    }
}
